% Cycloidal Gearbox Optimization Toolkit
% (C) Roman Król
% University of Technology and Humanities in Radom, Poland
% December 2018
function grho=GearRho(e, zk, zs, m, q, alpha)
    r=e*(zs+1)/m;
    grho=((r*sin(alpha) - q*sin(alpha ...
        + atan(sin(alpha*zs)/(cos(alpha*zs) ...
        + 1/m)))*(((zs*sin(alpha*zs)^2)/(cos(alpha*zs) ...
        + 1/m)^2 + (zs*cos(alpha*zs))/(cos(alpha*zs) ...
        + 1/m))/(sin(alpha*zs)^2/(cos(alpha*zs) + 1/m)^2 + 1) ...
        + 1) + e*zk*sin(alpha*zk))^2 + (r*cos(alpha) - q*cos(alpha ...
        + atan(sin(alpha*zs)/(cos(alpha*zs) + 1/m)))*(((zs*sin(alpha*zs)^2)...
        /(cos(alpha*zs) + 1/m)^2 + (zs*cos(alpha*zs))...
        /(cos(alpha*zs) + 1/m))/(sin(alpha*zs)^2/(cos(alpha*zs)...
        + 1/m)^2 + 1) + 1) + e*zk*cos(alpha*zk))^2)^(3/2)/((r*cos(alpha) ...
        - q*cos(alpha + atan(sin(alpha*zs)/(cos(alpha*zs) + 1/m)))...
        *(((zs*sin(alpha*zs)^2)/(cos(alpha*zs) + 1/m)^2 ...
        + (zs*cos(alpha*zs))/(cos(alpha*zs) + 1/m))/(sin(alpha*zs)^2 ...
        /(cos(alpha*zs) + 1/m)^2 + 1) + 1) + e*zk*cos(alpha*zk))...
        *(r*cos(alpha) - q*cos(alpha + atan(sin(alpha*zs)/...
        (cos(alpha*zs) + 1/m)))*(((zs*sin(alpha*zs)^2)/...
        (cos(alpha*zs) + 1/m)^2 + (zs*cos(alpha*zs))/(cos(alpha*zs) ...
        + 1/m))/(sin(alpha*zs)^2/(cos(alpha*zs) + 1/m)^2 + 1) + 1)^2 ...
        + e*zk^2*cos(alpha*zk) - q*sin(alpha + atan(sin(alpha*zs)...
        /(cos(alpha*zs) + 1/m)))*(((2*zs^2*sin(alpha*zs)^3)/(cos(alpha*zs)...
        + 1/m)^3 - (zs^2*sin(alpha*zs))/(cos(alpha*zs) + 1/m) ...
        + (3*zs^2*cos(alpha*zs)*sin(alpha*zs))/(cos(alpha*zs) ...
        + 1/m)^2)/(sin(alpha*zs)^2/(cos(alpha*zs) + 1/m)^2 + 1) ...
        - (((zs*sin(alpha*zs)^2)/(cos(alpha*zs) + 1/m)^2 ...
        + (zs*cos(alpha*zs))/(cos(alpha*zs) + 1/m))*((2*zs*sin(alpha*zs)^3)...
        /(cos(alpha*zs) + 1/m)^3 + (2*zs*cos(alpha*zs)*sin(alpha*zs))...
        /(cos(alpha*zs) + 1/m)^2))/(sin(alpha*zs)^2/(cos(alpha*zs) ...
        + 1/m)^2 + 1)^2)) + (r*sin(alpha) - q*sin(alpha + atan(sin(alpha*zs)...
        /(cos(alpha*zs) + 1/m)))*(((zs*sin(alpha*zs)^2)/(cos(alpha*zs) + 1/m)^2 ...
        + (zs*cos(alpha*zs))/(cos(alpha*zs) + 1/m))/(sin(alpha*zs)^2 ...
        /(cos(alpha*zs) + 1/m)^2 + 1) + 1) + e*zk*sin(alpha*zk))...
        *(r*sin(alpha) - q*sin(alpha + atan(sin(alpha*zs)/(cos(alpha*zs) ...
        + 1/m)))*(((zs*sin(alpha*zs)^2)/(cos(alpha*zs) + 1/m)^2 ...
        + (zs*cos(alpha*zs))/(cos(alpha*zs) + 1/m))/(sin(alpha*zs)^2 ...
        /(cos(alpha*zs) + 1/m)^2 + 1) + 1)^2 + e*zk^2*sin(alpha*zk) ...
        + q*cos(alpha + atan(sin(alpha*zs)/(cos(alpha*zs) + 1/m))) ...
        *(((2*zs^2*sin(alpha*zs)^3)/(cos(alpha*zs) + 1/m)^3 ...
        - (zs^2*sin(alpha*zs))/(cos(alpha*zs) + 1/m)...
        + (3*zs^2*cos(alpha*zs)*sin(alpha*zs))/(cos(alpha*zs) ...
        + 1/m)^2)/(sin(alpha*zs)^2/(cos(alpha*zs) + 1/m)^2 + 1) ...
        - (((zs*sin(alpha*zs)^2)/(cos(alpha*zs) + 1/m)^2 ...
        + (zs*cos(alpha*zs))/(cos(alpha*zs) + 1/m))*((2*zs*sin(alpha*zs)^3)...
        /(cos(alpha*zs) + 1/m)^3 + (2*zs*cos(alpha*zs)*sin(alpha*zs))...
        /(cos(alpha*zs) + 1/m)^2))/(sin(alpha*zs)^2/(cos(alpha*zs) ...
        + 1/m)^2 + 1)^2)));
end